﻿@model I3Teck.AndonAlarm.ViewModels.AndonTvViewModel
@{
    Layout = null;
}
<html>
<head>
    <title>Tegra| Alerta de abastecimiento</title>
    <link href="~/assets/vendors/base/vendors.bundle.css" rel="stylesheet" type="text/css"/>
    <link href="~/assets/base/style.bundle.css" rel="stylesheet" type="text/css"/>
    <link href="~/tegra.css" rel="stylesheet" type="text/css"/>
    <link href="~/assets/css/Site.css" rel="stylesheet"/>
    <link rel="shortcut icon" href="~/assets/favicon.ico"/>
    <style>
        body {
            font-family: Roboto;
            font-weight: 400;
        }

        .timer {
            position: absolute;
            z-index: 101;
            bottom: 0;
            left: 0;
            right: 0;
            background: #dd5608;
            text-align: center;
            line-height: 2.5;
            overflow: hidden;
            -webkit-box-shadow: 0 0 5px black;
            -moz-box-shadow: 0 0 5px black;
            box-shadow: 0 0 5px black;
            color: white;
            font-size: 30px;
            display: none;
        }

        .timer.active {
            display: block;
            -webkit-animation-name: fadeIn;
            -webkit-animation-duration: 0.6s;
            -webkit-animation-timing-function: ease-in-out;
            -webkit-animation-direction: alternate;
        }

        .layoutJSON {
            background: #ddd;
            border: 1px solid black;
            margin-top: 10px;
            padding: 10px;
        }

        .eventsJSON {
            background: #ddd;
            border: 1px solid black;
            margin-top: 10px;
            padding: 10px;
            height: 100px;
            overflow-y: scroll;
        }

        .columns {
            -moz-columns: 120px;
            -webkit-columns: 120px;
            columns: 120px;
        }

        .vue-grid-item:not(.vue-grid-placeholder) { border-radius: 10px; }

        .vue-grid-item.resizing { opacity: 0.9; }

        .vue-grid-item.static { background: #cce; }

        .blink {
            text-decoration: blink;
            -webkit-animation-name: blinker;
            -webkit-animation-duration: 0.6s;
            -webkit-animation-iteration-count: 12;
            -webkit-animation-timing-function: ease-in-out;
            -webkit-animation-direction: alternate;
        }

        .vue-grid-item .text {
            font-size: calc(1rem+1.5vw);
            font-weight: bold;
            text-align: center;
            position: absolute;
            top: 0;
            bottom: 10;
            left: 0;
            right: 0;
            height: 24px;
            color: #ffffff;
        }

        .vue-grid-item .building-tag {
            width: 5%;
            height: 50%;
            float: right;
            position: relative;
            margin-top: 10%;
            border-top-left-radius: 4px;
            border-bottom-left-radius: 4px;
        }

        .pl-one { background-color: #4285F4; }

        .pl-two { background-color: #b9ffb4; }

        .pl-three { background-color: #0F9D58; }

        .pl-four { background-color: #ff6262; }

        .pl-five { background-color: #a292ff; }


        .pl-six { background-color: #a985d1; }

        .pl-seven { background-color: #59d0ef; }

        .pl-eight { background-color: #9b9696; }

        .pl-nine { background-color: #fab786; }


        .pl-ten { background-color: #ff6d4c; }

        .vue-grid-item.pl-workless {
            background-color: darkgrey !important;
        }

        .vue-grid-item.pl-warning { background-color: #f78624 !important; }

        .vue-grid-item.pl-alert { background-color: #d83f45 !important; }

        .vue-grid-item.pl-complete { background-color: #6ed46ead !important; }

        .vue-grid-item .minMax { font-size: 12px; }

        .vue-grid-item .add { cursor: pointer; }

        .pl-legend {
            list-style: none;
            margin-top: -21px;
        }

        .pl-legend li {
            float: left;
            color: white;
            padding-left: 28px;
            font-size: 15px;
            margin-top: 8px;
        }

        .comment-text {
            font-size: 1.6vw;
            color: white;
            position: absolute;
            margin-top: 2vw;
            margin-left: 2vw;
            text-align: center;
        }

        .text-style {
            font-size: 1vw;
            color: white;
            font-weight: bold;
            position: absolute;
            margin-left: 3.5vw;
            text-align: center;
        }

        .text-comment {
            font-size: 1.4vw;
            color: white;
            font-weight: bold;
            position: absolute;
            margin-top: 2vw;
            margin-left: 1vw;
            text-align: center;
        }

        .pl-legend li .pl-badge {
            width: 30px;
            height: 30px;
            position: absolute;
            margin-top: 3px;
            margin-left: -24px;
            border-radius: 1px;
        }

        .fade-enter-active, .fade-leave-active { transition: opacity 1s; }

        .fade-enter, .fade-leave-to /* .fade-leave-active below version 2.1.8 */ { opacity: 0; }

        @@-webkit-keyframes fadeIn {
            from { opacity: 0; }

            to { opacity: 1; }
        }

        @@-webkit-keyframes blinker {
            from { opacity: 1.0; }

            to { opacity: 0.0; }
        }
    </style>

</head>
<body style="background: #666; padding-top: 0;">
    <audio id="audio" src="/assets/sounds/tv_production_alarm3.mp3"></audio>
    <audio id="audio-27-calle" src="/assets/sounds/Alarma_27_calle.mp3"></audio>

    <img class="rounded mx-auto d-block" src="~/assets/media/img/Tegra_LogoHorizontal_White.png" width="200" />
    <div id="app">
        <div>
            <div id="content" v-if="layout ">

                <grid-layout :layout.sync="@Model.ShowAllLines == 1?alertedLines:layout"
                             :col-num.sync="nCols"
                             :row-height.sync="side"
                             :is-draggable="false"
                             :is-resizable="false"
                             :vertical-compact="true"
                             :margin="[10, 10]"
                             :use-css-transforms="true">
                    <div v-if="alertedLines.length==0 && @Model.ShowAllLines == 1">
                        <div style="text-align: center; margin-top: 15vh">
                            <h1 style="color: whitesmoke;font-size: 100px; ">NO ALERTED LINES</h1>
                        </div>
                    </div>
                    <grid-item class="align-content-center" v-bind:class="style(item)" v-for="item in @Model.ShowAllLines == 1?alertedLines:layout" v-bind:key="item.id"
                               :x.sync="item.x"
                               :y.sync="item.y"
                               :w.sync="item.w"
                               :h.sync="item.h"
                               :i.sync="item.i" v-resize-text="{ratio:@Model.ShowAllLines == 1?1:9, minFontSize: '24px', maxFontSize: '100px', delay: 200}">
                        <div v-bind:class="getColor(item.building)" class="building-tag"></div>
                        <div v-if="item.alert!==null">
                            <div v-if="item.alert.comment">
                                <transition name="fade" mode="out-in">
                                    <div v-if="flag">
                                        <label class="text" v-resize-text="{ratio:@Model.ShowAllLines == 1?1:2,minFontSize: '24px', maxFontSize: '100px', delay: 200}">
                                            {{item.alert.comment ?item.alert.comment.substring(0,6): item.name}}
                                        </label>
                                    </div>
                                    <label v-else class="text">{{item.name}}</label>
                                </transition>
                            </div>
                            <label v-else class="text">{{item.name}}</label>
                        </div>
                        <label v-else class="text">{{item.name}}</label>
                    </grid-item>
                </grid-layout>
            </div>
            <timer start="10" increment="10" @@time-out="tryConnect"></timer>
        </div>
        <div v-if="layout.length>0 &&@Model.ShowAllLines == 0 || alertedLines.length>0 && @Model.ShowAllLines == 1">
            <ul class="pl-legend">
                <li style="margin-left: 3vw; margin-top: 0.5vw" class="" v-for="alert in alertType">
                    <div class="pl-badge" v-bind:style="{background:alert.color}"></div>
                    <p style="margin-left: 1vw;font-size:20px">{{alert.name}}</p>
                </li>
            </ul>
        </div>
    </div>
    <script src="~/lib/signalr/dist/browser/signalr.js"></script>
    <script src="~/lib/vue/dist/vue.js"></script>
    <script src="~/lib/vue-grid-layout/dist/vue-grid-layout.umd.js"></script>
    <script src="~/lib/axios/dist/axios.js"></script>
    <script src="~/assets/scripts/vue-resize-text.umd.min.js"></script>
    <script>
        var FitText = VueResizeText;
        var GridLayout = VueGridLayout.GridLayout;
        var GridItem = VueGridLayout.GridItem;
        var colors = [
            "pl-two", "pl-four", "pl-five", "pl-six", "pl-seven", "pl-eight", "pl-nine", "pl-ten"
        ];
        var ConnectionEventBus = new Vue();
        var Timer = {
            template: `<div class='timer' v-bind:class='{active: isRunning}' >
                Conexión con el servidor perdida intentando contectar en
             <b>{{time}} segundos</b>
            </div>`,
            props: ["start", "increment"],
            data: function() {
                return {
                    timer: null,
                    isRunning: false,
                    time: 0,
                    initialStart: 0
                };
            },
            mounted: function() {
                this.initialStart = this.start;
                ConnectionEventBus.$on("disconnected", this.startTimer);
                ConnectionEventBus.$on("connected", this.stopTimer);
            },
            methods: {
                startTimer: function() {
                    var self = this;
                    self.time = self.start;
                    self.initialStart = self.start;
                    self.isRunning = true;
                    self.timer = setInterval(function() {
                            if (self.time > 0) {
                                self.time--;
                            } else {
                                self.$emit("time-out");
                                self.initialStart = parseInt(self.initialStart) + parseInt(self.increment);
                                self.time = self.initialStart;
                            }
                        },
                        1000);
                },
                stopTimer: function() {
                    clearInterval(this.timer);
                    this.isRunning = false;
                },
                callFinish() {

                }
            }
        };
        window.vm = new Vue({
            el: '#app',
            components: {
                GridLayout,
                GridItem,
                Timer,
                FitText
            },
            data: function() {
                return {
                    layout: [],
                    alertedLines: [],
                    nCols: 1,
                    connection: null,
                    side: 1,
                    buildings: [],
                    flag: false,
                    alertType: [
                        { name: "Warning", color: "#f78624" },
                        { name: "Alert", color: "#d83f45" },
                        { name: "Workless", color: "darkgrey" }
                    ]
                };
            },
            mounted: function() {
                this.getProductionLines();
                this.startTransition();
            },
            created: function() {
                this.connection = new signalR
                    .HubConnectionBuilder()
                    .withUrl("/andon/alerts")
                    .configureLogging(signalR.LogLevel.Information)
                    .build();
                var self = this;
                this.connection.on("ReceiveAlert",
                    function(productionLineId, alert) {
                        if (@Model.FactoryId == 4) {
                            document.getElementById("audio-27-calle").play();

                        } else {
                            document.getElementById("audio").play();

                        }
                        var items = self.layout.filter(function(item) {
                            return item.id === productionLineId;
                        });
                        for (var i = 0; i < items.length; i++) {
                            items[i].alert = alert;
                            items[i].isNew = true;
                        }
                        if (@Model.ShowAllLines == 1) {
                        self.alertedLines = self.layout.filter(function(line) {
                            return line.alert != null;
                        });
                        self.setLayoutDimension(self.alertedLines.length);
                        var data = self.drawItems(self.alertedLines);
                        self.drawBuildings(self.alertedLines);
                        self.alertedLines = data;
                        items = self.layout.filter(function(item) {
                            return item.id === productionLineId;
                        });
                        for (var i = 0; i < items.length; i++) {
                            items[i].alert = alert;
                            items[i].isNew = true;
                        }
                    }
                });

            this.connection.onclose(function() {
                ConnectionEventBus.$emit("disconnected");
            });
            this.connection.on("RemoveAlert",
                function(productionLineId) {
                    var items = self.layout.filter(function(item) {
                        return item.id === productionLineId;
                    });
                    for (var i = 0; i < items.length; i++) {
                        items[i].alert = null;
                        items[i].isComplete = true;
                    }


                    if (@Model.ShowAllLines == 1) {
                        var lines = self.alertedLines.filter(function(item) {
                            return item.id === productionLineId;
                        });
                        for (var i = 0; i < lines.length; i++) {
                            lines[i].alert = null;
                            lines[i].isComplete = true;
                        }
                        setTimeout(function() {
                                self.alertedLines = self.layout.filter(function(line) {
                                    return line.alert != null;
                                });
                                self.setLayoutDimension(self.alertedLines.length);
                                var data = self.drawItems(self.alertedLines);
                                self.drawBuildings(self.alertedLines);
                                self.alertedLines = data;
                            },
                            6000);
                    }
                });
            var self = this;
            this.connection.start().then(function() {
                ConnectionEventBus.$emit("connected");
                console.log(this);
                self.connection.invoke("AddToGroup", '@Model.FactoryId' + "_" + '@Model.ProcessId')
                    .catch(err => console.error(err.toString()));
            }).catch(function(err) {
                console.log(err);
            });

            window.addEventListener("resize",
                function() {
                    self.setLayoutDimension(self.layout.length);
                });
        },
        computed: {},
        ready: function() {
            var vm = this;
        },
        methods: {
            click: function() {
                alert('clicked');
            },
            tryConnect: function() {
                console.log("trying to connect");
                var self = this;
                this.connection.start().then(function() {

                    ConnectionEventBus.$emit("connected");
                    self.getProductionLines();

                }).catch(function(err) {
                });
            },
            setLayoutDimension: function(dataLength) {
                var nCol = Math.ceil(Math.sqrt(dataLength));
                var side = (window.innerHeight - 250) / Math.ceil(dataLength / nCol);
                this.nCols = nCol;
                this.side = side;
            },
            getProductionLines: function() {
                var self = this;
                self.buildings = [];
                var data;
                axios
                    .get("/api/Andon/@Model.FactoryId/@Model.ProcessId/ProductionLinesTv")
                    .then(function(response) {

                        if (@Model.ShowAllLines == 1) {
                            self.alertedLines = response.data.filter(function(line) {
                                return line.alert != null;
                            });
                            self.setLayoutDimension(self.alertedLines.length);
                            self.layout = response.data;
                            data = self.drawItems(self.alertedLines);
                            self.drawBuildings(self.alertedLines);
                            self.alertedLines = data;

                        } else {
                            self.setLayoutDimension(response.data.length);
                            data = self.drawItems(response.data);
                            self.drawBuildings(response.data);
                            self.layout = data;

                        }
                        console.log(self.buildings);
                        if (self.layout.length !== 0) {
                            var newAlerts = false;
                            for (var i = 0; i < self.layout.length; i++) {
                                var items = data.filter(function(item) {
                                    return item.id === self.layout[i].id;
                                });
                                for (var j = 0; j < items.length; j++) {
                                    if (!items[j].alert && self.layout[i].alert) {
                                        //deleted
                                        self.layout[i].isComplete = true;
                                    }
                                    if (items[j].alert && !self.layout[i].alert) {
                                        //created
                                        self.layout[i].isNew = true;
                                        newAlerts = true;
                                    }
                                    self.layout[i].alert = items[j].alert;
                                }
                            }
                        } else {
                            self.layout = data;
                        }

                        if (newAlerts) {
                            document.getElementById("audio").play();
                        }
                    });
            },
            getColor: function(name) {
                var code = name.split("").reduce(function(a, b) {
                        return a + b.charCodeAt(0) * name.length;
                    },
                    0);
                return colors[code % colors.length];
            },
            style: function (item) {
               
                var classNew = (item.building == 'EB-P01') ? 'pl-one' : 'pl-three';
                if (item.isNew) {
                    classNew += " blink ";
                    setTimeout(function() {
                            item.isNew = false;
                        },
                        5000);
                }
                if (item.alert) {
                    if (item.alert.andonAlertTypeId === 1) {
                        return classNew + " pl-alert";

                    } else if (item.alert.andonAlertTypeId === 2) {
                        return classNew + " pl-warning";
                    }
                    else if (item.alert.andonAlertTypeId === 3) {
                        return classNew + " pl-workless";
                    } 
                } else if (item.isComplete) {
                    setTimeout(function() {
                            item.isComplete = false;
                        },
                        8000);
                    return classNew + " blink";
                }
                return classNew;
            },
            startTransition: function() {
                var self = this;
                this.timer = setInterval(() => {
                        (self.flag == false) ? self.flag = true : self.flag = false;
                    },
                    5000
                );
            },
            drawItems: function(lines) {
                var self = this;
                var col = 0;
                var row = 0;
                var data = lines.map(function(item, i) {
                    item.x = col;
                    item.y = row;
                    item.w = 1;
                    item.h = 1;
                    item.i = i;
                    item.isNew = false;
                    item.isComplete = false;
                    item.name = item.name.replace('EB-', '');
                    item.name = item.name.replace('27C-', '');
                    if (col === self.nCols - 1) {
                        row++;
                        col = 0;
                    } else {
                        col++;
                    }

                    return item;
                });
                return data;
            },
            drawBuildings: function(lines) {
                var self = this;
                self.buildings = [];
                this.buildings = lines.map(function(item) {
                    return item.building;
                }).filter(function(val, i, self) {
                    return self.indexOf(val) === i;
                });
            }
        }
    });
    </script>
    <script src="https://ajax.googleapis.com/ajax/libs/webfont/1.6.16/webfont.js"></script>
    <script>
        WebFont.load({
            google: { "families": ["Poppins:300,400,500,600,700", "Roboto:300,400,500,600,700"] },
            active: function () {
                sessionStorage.fonts = true;
            }
        });

        function funError(message) {
            swal({
                title: "Error",
                text: message,
                type: "error"
            });
        }
    </script>
</body>
</html>
